De fant en sårbarhet i Ghostscript som ble utnyttet gjennom ImageMagick

Nylig brøt nyheten det identifisert en kritisk sårbarhet (som allerede er katalogisert som CVE-2021-3781) i Ghostscript (et sett med verktøy for behandling, konvertering og generering av dokumenter i PostScript- og PDF -formater) som gjør det mulig å utføre vilkårlig kode når du behandler en spesialformatert fil.

utgangspunktet, Emil Lerner påpekte at det var et problem og som også var den som snakket om sårbarhet 25. augusteller på den siste St. Petersburg ZeroNights X -konferansen (I rapporten viste hvordan Emile i bug bounty -programmet for å bruke sårbarheten til å få belønninger for demonstrasjonsangrep på AirBNB, Dropbox og Yandex.Realty -tjenester).

5. september dukket det opp en funksjonell utnyttelse offentlig domene som gjør det mulig å angripe Ubuntu 20.04-systemer ved å overføre et webskript som kjører på serveren ved hjelp av php-imagemagick-pakken, et spesialkonstruert dokument lastet under dekke av et bilde.

Vi har en løsning i testing akkurat nå.

Siden denne utnyttelsen tilsynelatende har sirkulert siden mars og er fullstendig offentlig siden minst 25. august (så mye for ansvarlig avsløring!), Er jeg tilbøyelig til å legge ut reparasjonen offentlig så snart vi har fullført testing og gjennomgang.

Selv om det på den annen side også er nevnt at ifølge foreløpige data, en slik utnyttelse har blitt brukt siden mars og det ble kunngjort det kan angripe systemer som kjører GhostScript 9.50, men det har blitt avslørt at sårbarheten har fortsatt i alle påfølgende versjoner av GhostScript, inkludert Git -utviklingsversjon 9.55.

En korreksjon ble deretter foreslått 8. september og etter fagfellevurdering ble det akseptert i GhostScript -depotet 9. september.

Som jeg nevnte tidligere, siden utnyttelsen har vært "i naturen" i minst 6 måneder, har jeg allerede sendt oppdateringen til vårt offentlige depot; å holde lappen hemmelig i denne situasjonen virket ubrukelig.

Jeg vil gjøre denne feilen offentlig før virksomheten stenger (Storbritannia) på fredag ​​igjen, med mindre det er sterke og overbevisende argumenter for ikke å gjøre det (du kan fortsatt koble til den, slik at den blir offentlig, vil ikke endre nettadressen).

Problemet skyldes evnen til å omgå isolasjonsmodusen "-dSAFER" på grunn av utilstrekkelig validering av PostScript -enhetsparametrene "% pipe%", som tillot å utføre vilkårlige skallkommandoer.

For eksempel, for å kjøre identifikasjonsverktøyet på et dokument, trenger du bare å angi strengen "(% pipe% / tmp / & id) (w) file" eller "(% pipe% / tmp /; id) (r) fil ».

Som en påminnelse, sårbarhetene i Ghostscript er mer alvorlige, siden denne pakken brukes i mange applikasjoner populær for behandling av PostScript- og PDF -formater. For eksempel kalles Ghostscript når du lager miniatyrbilder på skrivebordet, når du indekserer data i bakgrunnen og når du konverterer bilder. For et vellykket angrep er det i mange tilfeller nok å laste ned utnyttelsesfilen eller bla gjennom katalogen med den i en filbehandling som støtter visning av miniatyrbilder av dokumenter, for eksempel i Nautilus.

Sårbarheter i Ghostscript kan også utnyttes via bildekontrollere basert på ImageMagick- og GraphicsMagick -pakkene, som sender en JPEG- eller PNG -fil, som inneholder PostScript -kode i stedet for et bilde (denne filen vil bli behandlet i Ghostscript, siden MIME -typen gjenkjennes av innholdet, og uten avhengig av utvidelsen).

Som en løsning for å beskytte mot å utnytte sårbarheten gjennom den automatiske miniatyrgeneratoren i GNOME og ImageMagick, anbefales det å deaktivere evince-thumbnailer-samtalen i /usr/share/thumbnailers/evince.thumbnailer og deaktivere gjengivelse av PS, EPS, PDF og XPS -formater i ImageMagick,

Endelig Det nevnes at problemet i mange distribusjoner fremdeles ikke er løst (statusen for utgivelsen av oppdateringer kan sees på sidene til Debian, Ubuntu, Fedora, SUSE, RHEL, Arch Linux, FreeBSD, NetBSD).

Det nevnes også at utgivelsen av GhostScript med eliminering av sårbarheten er planlagt å bli publisert før slutten av måneden. Hvis du vil vite mer om det, kan du sjekke detaljene i følgende lenke.


Innholdet i artikkelen følger våre prinsipper for redaksjonell etikk. Klikk på for å rapportere en feil her.

Bli den første til å kommentere

Legg igjen kommentaren

Din e-postadresse vil ikke bli publisert. Obligatoriske felt er merket med *

*

*

  1. Ansvarlig for dataene: Miguel Ángel Gatón
  2. Formålet med dataene: Kontroller SPAM, kommentaradministrasjon.
  3. Legitimering: Ditt samtykke
  4. Kommunikasjon av dataene: Dataene vil ikke bli kommunisert til tredjeparter bortsett fra ved juridisk forpliktelse.
  5. Datalagring: Database vert for Occentus Networks (EU)
  6. Rettigheter: Når som helst kan du begrense, gjenopprette og slette informasjonen din.